<?php


namespace Service;

use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use Repository\Project as ProjectRepository;

class Project
{
    const PROJECT_TYPE_PRODUCT = Entities\Project::PROJECT_TYPE_PRODUCT;

    /**
     * @var ProjectRepository
     */
    private $projectRepository;

    /**
     * @var EntityManager
     */
    private $entityManager;

    public function __construct(EntityManager $entityManager, ProjectRepository $projectRepository)
    {
        $this->projectRepository = $projectRepository;
        $this->entityManager = $entityManager;
    }

    public static function getProductProject(Entities\Project $project = null)
    {
        $productProject = null;
        if ($project) {
            if ($project->getProjectType()->getExternaltype() == self::PROJECT_TYPE_PRODUCT) {
                $productProject = $project;
            } else {
                $productProject = self::getProductProject($project->getParent());
            }
        }
        return $productProject;
    }

    /**
     * @return array
     */
    public function findProjectsByOperador(): array
    {
        return $this->projectRepository->findProjectsByOperador(getResourceId());
    }
}
