import { Singleton } from '@zeedhi/core';
import { Modal, Tree } from '@zeedhi/common';
import Store from '@/store';
import Messages from '@/services/Messages';
// import { PmLibDialogService, PmLibFormSave, PmLibUtil } from '@zeedhi/pm-lib/index';

@Singleton
export class AclLabelsDuplicateLabelsModalController {
	get duplicateLabelsModal(): Modal {
		return Store.getters['AclLabels/getDuplicateLabelsModal'];
	}

	get originalNodes() {
		return Store.getters['AclLabels/getOriginalNodes'];
	}

	get aclLabelsTreeComponent(): Tree {
		return Store.getters['AclLabels/getAclLabelsTreeComponent'];
	}

	get hasChanges(): boolean {
		return Store.getters['AclLabels/getHasChanges'];
	}

	set hasChanges(value: boolean) {
		Store.commit('AclLabels/setHasChanges', value);
	}

	get getMessage(): string {
		return Messages.MSG_DUPLICATE_LABEL_IMPORT_MENU;
	}

	private closeDuplicateLabelsModal() {
		this.duplicateLabelsModal?.hide();
		this.aclLabelsTreeCancel();
	}

	public aclLabelsTreeCancel() {
		if (this.originalNodes) {
			this.aclLabelsTreeComponent.nodes = [...this.originalNodes];
		} else {
			this.aclLabelsTreeComponent.nodes = [];
		}
		this.hasChanges = false;
		this.aclLabelsTreeComponent.clearSelection();
	}
}
